<?php

/**
 * default actions.
 *
 * @package    drspinksadmin
 * @subpackage default
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class defaultActions extends sfActions
{
    /**
    * Executes index action
    *
    * @param sfRequest $request A request object
    */
    public function executeIndex(sfWebRequest $request)
    {
        $this->redirect('pages/index');
    }

    /**
    * Executes login action
    *
    * @param sfRequest $request A request object
    */
    public function executeLogin(sfWebRequest $request)
    {
        $this->getResponse()->setSlot('title', 'Login');
        $this->getResponse()->setSlot('content', 'Please use the form below to login to the admin site.');

        $this->form = new LoginForm();

        if ($request->isMethod('post'))
        {
            $this->form->bind($request->getParameter('login'));

            if ($this->form->isValid())
            {
                $values = $this->form->getValues();

                $user = UsersPeer::findByUsernameAndPassword($values['username'], $values['password']);

                if ($user instanceof Users)
                {
                    $this->getUser()->setAttribute('user_id', $user->getUserId());
                    $this->getUser()->setAuthenticated(true);
                    $this->redirect('@homepage');
                }
                else
                {
                    $this->getUser()->setFlash('error', 'There was an error with your Username/Password combination. Please try again.');
                    $this->redirect('default/login');
                }
            }
            else
            {
                $this->getUser()->setFlash('error', 'You need to enter a valid username and password.');
                $this->redirect('default/login');
            }
        }
    }

    /**
    * Executes logout action
    *
    * @param sfRequest $request A request object
    */
    public function executeLogout(sfWebRequest $request)
    {
        $this->getUser()->getAttributeHolder()->remove('user_id');
        $this->getUser()->setAuthenticated(false);
        $this->redirect('@login');
    }
}
