<?php

/**
 * Base project form.
 *
 * @package    drspinks
 * @subpackage contact us form
 * @author     Brian Raines
 */
class LoginForm extends BaseForm
{
    public function configure()
    {
        $this->setWidgets(array(
            'username'            => new sfWidgetFormInputText(),
            'password'            => new sfWidgetFormInputPassword(),
        ));

        $this->widgetSchema->setNameFormat('login[%s]');

        $this->widgetSchema->setLabels(array(
            'username'            => 'Username',
            'password'            => 'Password',
        ));

        $this->setValidators(array(
            'username'            => new sfValidatorString(),
            'password'            => new sfValidatorString(),
        ));

        parent::setup();
    }
}