<?php

/**
 * messages actions.
 *
 * @package    drspinksadmin
 * @subpackage messages
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class messagesActions extends sfActions
{
    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeIndex(sfWebRequest $request)
    {
        $this->getResponse()->setSlot('title', 'Contact Messages');
        $this->getResponse()->setSlot('content', 'Below are the messages that people have sent you.  Messages marked as bold have not been read.');
        $this->messages = MessagePeer::findAllMessages();

        $criteria = new Criteria();
        $criteria->addDescendingOrderByColumn(MessagePeer::CREATED_AT);

        $this->pager = new sfPropelPager('Message', 20);
        $this->pager->setCriteria($criteria);
        $this->pager->setPage($request->getParameter('page', 1));
        $this->pager->init();
    }

    /**
     * Executes view action
     *
     * @param sfRequest $request A request object
     */
    public function executeView(sfWebRequest $request)
    {
        $this->getResponse()->setSlot('title', 'View Message');
        $this->getResponse()->setSlot('content', 'You have been contacted via the form on SpinksNeurosurgery.com with the following information:');

        $this->message = MessagePeer::retrieveByPK($request->getParameter('message_id'));

        if (!($this->message instanceof Message))
        {
            $this->getUser()->setFlash('error', 'The message you were attempting to view could not be found.');
            $this->redirect('@messages');
        }

        $this->message->setIsRead(1);
        $this->message->save();
    }
}
