<?php use_helper('Format'); ?>
<?php if ($news_items->count() > 0): ?>
<div class="grid">
    <table border="0" cellpadding="0" cellspacing="0">
        <thead>
        <tr>
            <th>Title</th>
            <th>News/Event</th>
            <th>Date</th>
            <th>Active</th>
            <th>Edit</th>
            <th>Delete</th>
        </tr>
        </thead>
        <tbody>
        <?php foreach ($news_items as $news_item): ?>
        <tr title="<?php echo $news_item->getContent(); ?>">
            <td nowrap><?php echo $news_item->getTitle(); ?></td>
            <td nowrap><?php echo ucwords(strtolower($news_item->getNewsItemType())); ?></td>
            <td nowrap><?php echo format_date($news_item->getNewsItemDate()); ?></td>
            <td nowrap><?php echo (($news_item->getIsActive()) ? 'Yes' : 'No'); ?></td>
            <td><?php echo link_to('Edit', '@news_edit?news_item_id='.$news_item->getNewsItemId(), array('class'=>'link edit')); ?></td>
            <td><a href="javascript:confirmDelete('<?php echo url_for('@news_delete?news_item_id='.$news_item->getNewsItemId()); ?>');" class="link delete">Delete</a></td>
        </tr>
        <?php endforeach; ?>
        </tbody>

    </table>
</div>

<div id="dialog-confirm" title="Delete News Item?">
    <p style="padding-left:45px; background: transparent url('/images/icons/software/V3/32x32/Symbol Warning 2.png') top left no-repeat;">This item will be permanently deleted and cannot be recovered. Are you sure?</p>
</div>

<script type="text/javascript">
    var delete_url = '';
    $(function() {
        $( "#dialog-confirm" ).dialog({
            autoOpen: false,
            resizable: false,
            width: 450,
            height:250,
            modal: true,
            buttons: {
                "Delete News Item": function() {
                    window.location = delete_url;
                    $( this ).dialog( "close" );
                    $( "#please-wait" ).dialog("open");
                },
                Cancel: function() {
                    delete_url = '';
                    $( this ).dialog( "close" );
                }
            }
        });
    });

    function confirmDelete(url)
    {
        delete_url = url;
        $( "#dialog-confirm" ).dialog('open');
    }
</script>

<?php endif; ?>