<?php use_helper('Format'); ?>
<?php if ($testimonials->count() > 0): ?>
<div class="grid">
    <table border="0" cellpadding="0" cellspacing="0">
        <thead>
        <tr>
            <th>Clients</th>
            <th>Active</th>
            <th>Edit</th>
            <?php if (count($testimonials) > 1): ?>
            <th colspan="2">Move</th>
            <?php endif; ?>
            <th>Delete</th>
        </tr>
        </thead>
        <tbody>
        <?php foreach ($testimonials as $testimonial): ?>
        <tr title="Message: <?php echo $testimonial->getMessage(); ?>">
            <td nowrap><?php echo $testimonial->getClientName(); ?></td>
            <td nowrap><?php echo (($testimonial->getIsActive()) ? 'Yes' : 'No'); ?></td>
            <td><?php echo link_to('Edit', '@testimonial_edit?testimonial_id='.$testimonial->getTestimonialId(), array('class'=>'link edit')); ?></td>
            <?php if (count($testimonials) > 1): ?>
            <td><?php if ($testimonial->getDisplayOrder() != '10'): ?><?php echo link_to('Up', '@testimonial_move_up?testimonial_id='.$testimonial->getTestimonialId(), array('class'=>'link move_up', 'onclick'=>'$("#please-wait").dialog("open");')); ?><?php endif; ?></td>
            <td><?php if ($testimonial->getDisplayOrder() != (count($testimonials)*10)): ?><?php echo link_to('Down', '@testimonial_move_down?testimonial_id='.$testimonial->getTestimonialId(), array('class'=>'link move_down', 'onclick'=>'$("#please-wait").dialog("open");')); ?><?php endif; ?></td>
            <?php endif; ?>
            <td><a href="javascript:confirmDelete('<?php echo url_for('@testimonial_delete?testimonial_id='.$testimonial->getTestimonialId()); ?>');" class="link delete">Delete</a></td>
        </tr>
        <?php endforeach; ?>
        </tbody>

    </table>
</div>

<div id="dialog-confirm" title="Delete Testimonial?">
    <p style="padding-left:45px; background: transparent url('/images/icons/software/V3/32x32/Symbol Warning 2.png') top left no-repeat;">This testimonial will be permanently deleted and cannot be recovered. Are you sure?</p>
</div>

<script type="text/javascript">
    var delete_url = '';
    $(function() {
        $( "#dialog-confirm" ).dialog({
            autoOpen: false,
            resizable: false,
            width: 450,
            height:250,
            modal: true,
            buttons: {
                "Delete Testimonial": function() {
                    window.location = delete_url;
                    $( this ).dialog( "close" );
                    $( "#please-wait" ).dialog("open");
                },
                Cancel: function() {
                    delete_url = '';
                    $( this ).dialog( "close" );
                }
            }
        });
    });

    function confirmDelete(url)
    {
        delete_url = url;
        $( "#dialog-confirm" ).dialog('open');
    }
</script>
<?php endif; ?>