<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
    <head>
        <?php include_http_metas() ?>
        <?php include_metas() ?>
        <?php include_title() ?>
        <link rel="shortcut icon" href="/favicon.ico" />
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
        <script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.17/jquery-ui.min.js"></script>
        <?php include_stylesheets() ?>
        <?php include_javascripts() ?>
        <script type="text/javascript">
            $(document).ready(function() {
                $( "#please-wait" ).dialog({
                    autoOpen: false,
                    resizable: false,
                    width: 230,
                    height:50,
                    modal: true,
                    dialogClass: "please-wait"
                });
            });
        </script>
    </head>
    <body>
        <div class="header">
            <div class="logo"><?php echo link_to('<img src="/images/admin/logo.png" width="411" height="23" border="0" />', '@homepage'); ?></div>
        </div>

        <div class="main_navigation">
            <div class="top_bar"></div>
            <div class="links">
            <?php if ($sf_user->isAuthenticated()): ?>
                <?php include_partial('global/navigation'); ?>
            <?php endif; ?>
            </div>
            <div class="bottom_bar"></div>
        </div>

        <?php include_partial('global/sub_navigation'); ?>

        <div class="flash">
        <?php if ($sf_user->hasFlash('notice')): ?>
            <div class="flash_success"><?php echo $sf_user->getFlash('notice') ?></div>
        <?php endif ?>
        <?php if ($sf_user->hasFlash('success')): ?>
            <div class="flash_success"><?php echo $sf_user->getFlash('success') ?></div>
        <?php endif ?>
        <?php if ($sf_user->hasFlash('info')): ?>
            <div class="flash_info"><?php echo $sf_user->getFlash('info') ?></div>
        <?php endif ?>
        <?php if ($sf_user->hasFlash('error')): ?>
            <div class="flash_error"><?php echo $sf_user->getFlash('error') ?></div>
        <?php endif ?>
        <?php if ($sf_user->hasFlash('warning')): ?>
            <div class="flash_warning"><?php echo $sf_user->getFlash('warning') ?></div>
        <?php endif ?>
        <?php if (has_slot('error')): ?>
            <div class="flash_error"><?php include_slot('error') ?></div>
        <?php endif ?>
        </div>

        <div class="content">
            <?php if (has_slot('title')): ?>
            <div class="title <?php echo $sf_params->get('module'); ?>"><?php include_slot('title') ?></div>
            <?php endif; ?>

            <div class="inner_content <?php echo $sf_params->get('module'); ?>">
                <?php if (has_slot('content')): ?>
                <?php include_slot('content') ?>
                <br />&nbsp;<br />
                <?php endif; ?>
                <?php echo $sf_content ?>
            </div>

        </div>

        <div id="please-wait" title="Please Wait">
            <div class="please-wait-text">Loading...</div>
        </div>
    </body>
</html>
