<?php

/**
 * news actions.
 *
 * @package    drspinks
 * @subpackage news
 * @author     Brian Raines
 *
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class newsActions extends sfActions
{
    public function preExecute()
    {
        $disabled_pages = sfConfig::get('app_disabled_pages');
        if (in_array($this->getModuleName().'|'.$this->getActionName(), $disabled_pages))
        {
            $this->redirect('@homepage');
        }

        $this->page = PagePeer::findByModuleAction($this->getModuleName(), $this->getActionName());
        if ($this->page instanceof Page)
        {
            $this->getResponse()->setSlot('title', $this->page->getTitle());
            $this->getResponse()->setSlot('sub_title', $this->page->getSubTitle());
            $this->getResponse()->setSlot('content', $this->page->getContent());
        }
    }

    /**
     * Executes OfficeInfo action
     *
     * @param sfRequest $request A request object
     */
    public function executeNews(sfWebRequest $request)
    {
        $c = new Criteria();
        $c->add(NewsItemPeer::NEWS_ITEM_TYPE, 'NEWS');
        $c->add(NewsItemPeer::IS_ACTIVE, TRUE);
        $c->addDescendingOrderByColumn(NewsItemPeer::NEWS_ITEM_DATE);
        $c->addDescendingOrderByColumn(NewsItemPeer::TITLE);
        $c->setLimit(10);

        $this->news_items = NewsItemPeer::doSelect($c);
    }

    /**
     * Executes OfficeInfo action
     *
     * @param sfRequest $request A request object
     */
    public function executeEvents(sfWebRequest $request)
    {
        $c = new Criteria();
        $c->add(NewsItemPeer::NEWS_ITEM_TYPE, 'EVENT');
        $c->add(NewsItemPeer::IS_ACTIVE, TRUE);
        $c->addAscendingOrderByColumn(NewsItemPeer::NEWS_ITEM_DATE);
        $c->addDescendingOrderByColumn(NewsItemPeer::TITLE);

        $this->news_items = NewsItemPeer::doSelect($c);
    }

    /**
     * Executes OfficeInfo action
     *
     * @param sfRequest $request A request object
     */
    public function executeNewsEvents(sfWebRequest $request)
    {
        $c = new Criteria();
        $c->add(NewsItemPeer::NEWS_ITEM_TYPE, 'NEWS');
        $c->add(NewsItemPeer::IS_ACTIVE, TRUE);
        $c->addDescendingOrderByColumn(NewsItemPeer::NEWS_ITEM_DATE);
        $c->addDescendingOrderByColumn(NewsItemPeer::TITLE);

        $this->news_items = NewsItemPeer::doSelect($c);

        $c = new Criteria();
        $c->add(NewsItemPeer::NEWS_ITEM_TYPE, 'EVENT');
        $c->add(NewsItemPeer::IS_ACTIVE, TRUE);
        $c->addDescendingOrderByColumn(NewsItemPeer::NEWS_ITEM_DATE);
        $c->addDescendingOrderByColumn(NewsItemPeer::TITLE);

        $this->events = NewsItemPeer::doSelect($c);
    }
}
