<?php use_helper('Format'); ?>

<div class="page_title"><?php echo $page->getTitle(); ?></div>
<div class="page_sub_title"><?php echo $page->getSubTitle(); ?></div>
<div class="page_content"><?php echo html_entity_decode($page->getContent()); ?></div>

<?php if (count($events) > 0): ?>
    <div id="news_items">
    <?php foreach ($events as $event): ?>
        <div class="news_item">
            <div class="title"><?php echo $event->getTitle(); ?></div>
            <?php if ($event->getEventEndDate() != ''): ?>
            <div class="date"><?php echo format_combined_date($event->getNewsItemDate(), $event->getEventEndDate()); ?></div>
            <?php else: ?>
            <div class="date"><?php echo format_date($event->getNewsItemDate()); ?></div>
            <?php endif; ?>

            <div class="content"><?php echo html_entity_decode($event->getContent()); ?></div>
            <?php if ($event->getExternalUrl() != ''): ?>
            <div class="external_url"><a href="<?php echo $event->getExternalUrl(); ?>" target="_blank">Read more</a></div>
            <?php endif; ?>
        </div>
    <?php endforeach; ?>
    </div>
<?php endif; ?>
