<?php

/**
 * offices actions.
 *
 * @package    drspinks
 * @subpackage offices
 * @author     Brian Raines
 *
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class officesActions extends sfActions
{
    public function preExecute()
    {
        $disabled_pages = sfConfig::get('app_disabled_pages');
        if (in_array($this->getModuleName().'|'.$this->getActionName(), $disabled_pages))
        {
            $this->redirect('@homepage');
        }

        $this->page = PagePeer::findByModuleAction($this->getModuleName(), $this->getActionName());
        if ($this->page instanceof Page)
        {
            $this->getResponse()->setSlot('title', $this->page->getTitle());
            $this->getResponse()->setSlot('sub_title', $this->page->getSubTitle());
            $this->getResponse()->setSlot('content', $this->page->getContent());
        }
    }

    /**
     * Executes OfficeInfo action
     *
     * @param sfRequest $request A request object
     */
    public function executeOfficeInfo(sfWebRequest $request)
    {
        //$this->getResponse()->setSlot('page_image', '/images/layout/Spinks-and-Child-Life-2.jpg');

        $c = new Criteria();
        $c->add(OfficePeer::IS_ACTIVE, TRUE);

        $this->offices = OfficePeer::doSelect($c);
    }
}
