<?php

class DisabledPagesFilter extends sfFilter
{
    protected $disabled_pages = array();

    public function execute($filterChain)
    {
        if ($this->isFirstCall())
        {
            $this->verifyNewsEvents();
            $this->verifyTestimonials();
            $this->verifyOffices();



            sfConfig::set('app_disabled_pages', $this->disabled_pages);
        }

        // Execute next filter
        $filterChain->execute();
    }

    protected function verifyNews()
    {
        $c = new Criteria();
        $c->add(NewsItemPeer::NEWS_ITEM_TYPE, 'NEWS');
        $c->add(NewsItemPeer::IS_ACTIVE, TRUE);

        return NewsItemPeer::doCount($c);
    }

    protected function verifyEvents()
    {
        $c = new Criteria();
        $c->add(NewsItemPeer::NEWS_ITEM_TYPE, 'EVENT');
        $c->add(NewsItemPeer::IS_ACTIVE, TRUE);

        return NewsItemPeer::doCount($c);
    }

    protected function verifyNewsEvents()
    {
        $news_count = $this->verifyNews();
        $events_count = $this->verifyEvents();

        if (($news_count + $events_count) == 0)
        {
            $this->disabled_pages[] = 'news|NewsEvents';
        }
    }

    protected function verifyTestimonials()
    {
        $c = new Criteria();
        $c->add(TestimonialPeer::IS_ACTIVE, TRUE);

        $count = TestimonialPeer::doCount($c);

        if ($count == 0)
        {
            //$this->disabled_pages[] = 'about|Testimonials';
        }
    }

    protected function verifyOffices()
    {
        $c = new Criteria();
        $c->add(OfficePeer::IS_ACTIVE, TRUE);

        $count = OfficePeer::doCount($c);

        if ($count == 0)
        {
            $this->disabled_pages[] = 'offices|OfficeInfo';
        }
    }
}