<?php

/**
 * Message filter form base class.
 *
 * @package    drspinks
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseMessageFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'first_name'         => new sfWidgetFormFilterInput(),
      'last_name'          => new sfWidgetFormFilterInput(),
      'interested_in'      => new sfWidgetFormFilterInput(),
      'preferred_response' => new sfWidgetFormFilterInput(),
      'email'              => new sfWidgetFormFilterInput(),
      'phone'              => new sfWidgetFormFilterInput(),
      'zip'                => new sfWidgetFormFilterInput(),
      'message'            => new sfWidgetFormFilterInput(),
      'created_at'         => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate())),
      'is_read'            => new sfWidgetFormFilterInput(array('with_empty' => false)),
    ));

    $this->setValidators(array(
      'first_name'         => new sfValidatorPass(array('required' => false)),
      'last_name'          => new sfValidatorPass(array('required' => false)),
      'interested_in'      => new sfValidatorPass(array('required' => false)),
      'preferred_response' => new sfValidatorPass(array('required' => false)),
      'email'              => new sfValidatorPass(array('required' => false)),
      'phone'              => new sfValidatorPass(array('required' => false)),
      'zip'                => new sfValidatorPass(array('required' => false)),
      'message'            => new sfValidatorPass(array('required' => false)),
      'created_at'         => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'is_read'            => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
    ));

    $this->widgetSchema->setNameFormat('message_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Message';
  }

  public function getFields()
  {
    return array(
      'message_id'         => 'Number',
      'first_name'         => 'Text',
      'last_name'          => 'Text',
      'interested_in'      => 'Text',
      'preferred_response' => 'Text',
      'email'              => 'Text',
      'phone'              => 'Text',
      'zip'                => 'Text',
      'message'            => 'Text',
      'created_at'         => 'Date',
      'is_read'            => 'Number',
    );
  }
}
