<?php

/**
 * NewsItem form.
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
class NewsItemForm extends BaseNewsItemForm
{
  public function configure()
  {
      $this->setWidgets(array(
            'title'             => new sfWidgetFormInputText(),
            'external_url'      => new sfWidgetFormInputText(),
            'content'           => new sfWidgetFormTextarea(),
            'is_active'         => new sfWidgetFormChoice(array(
                'choices'       => array(0 => 'No', 1 => 'Yes'),
            )),
            'news_item_type'    => new sfWidgetFormChoice(array(
                'choices'       => array('EVENT' => 'Event', 'NEWS' => 'News'),
            )),
            'news_item_date'    => new sfWidgetFormInputText(),
            'event_end_date'    => new sfWidgetFormInputText()
        ));

        $this->setValidators(array(
            'title'             => new sfValidatorString(),
            'external_url'      => new sfValidatorString(array('required' => false)),
            'content'           => new sfValidatorString(array('required' => false)),
            'is_active'         => new sfValidatorInteger(array('min' => 0, 'max' => 1)),
            'news_item_type'    => new sfValidatorString(),
            'news_item_date'    => new sfValidatorString(array('required' => false)),
            'event_end_date'    => new sfValidatorString(array('required' => false)),
        ));


        $this->widgetSchema->setNameFormat('news_item[%s]');

        $this->widgetSchema->setLabels(array(
            'title'             => 'Title',
            'external_url'      => 'URL',
            'content'           => 'Content',
            'is_active'         => 'Active',
            'news_item_type'    => 'News/Event',
            'news_item_date'    => 'Date',
            'event_end_date'    => 'End Date',
        ));
  }
}
