<?php

/**
 * Office form.
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
class OfficeForm extends BaseOfficeForm
{
    public function configure()
    {
        $this->setWidgets(array(
            'address_1'  => new sfWidgetFormInputText(),
            'address_2'  => new sfWidgetFormInputText(),
            'address_3'  => new sfWidgetFormInputText(),
            'city'       => new sfWidgetFormInputText(),
            'state'      => new sfWidgetFormInputText(),
            'zip'        => new sfWidgetFormInputText(),
            'phone'      => new sfWidgetFormInputText(),
            'fax'        => new sfWidgetFormInputText(),
            'is_active'         => new sfWidgetFormChoice(array(
                'choices'       => array(0 => 'No', 1 => 'Yes'),
            )),
        ));

        $this->setValidators(array(
            'address_1'  => new sfValidatorString(array('max_length' => 250)),
            'address_2'  => new sfValidatorString(array('required'=>false,'max_length' => 250)),
            'address_3'  => new sfValidatorString(array('required'=>false,'max_length' => 250)),
            'city'       => new sfValidatorString(array('max_length' => 250)),
            'state'      => new sfValidatorString(array('max_length' => 250)),
            'zip'        => new sfValidatorString(array('max_length' => 250)),
            'phone'      => new sfValidatorString(array('required'=>false,'max_length' => 250)),
            'fax'        => new sfValidatorString(array('required'=>false,'max_length' => 250)),
            'is_active'  => new sfValidatorInteger(array('required'=>false,'min' => 0, 'max' => 1)),
        ));

        $this->widgetSchema->setNameFormat('office[%s]');

        $this->widgetSchema->setLabels(array(
            'address_1' => 'Street Address Line 1',
            'address_2' => 'Street Address Line 2',
            'address_3' => 'Street Address Line 3',
            'city'      => 'City',
            'state'     => 'State',
            'zip'       => 'Zip',
            'phone'     => 'Phone',
            'fax'       => 'Fax',
            'is_active' => 'Active',
        ));
    }
}
