<?php

/**
 * Testimonial form.
 *
 * @package    drspinksadmin
 * @subpackage form
 * @author     Your name here
 */
class TestimonialForm extends BaseTestimonialForm
{
  public function configure()
  {
      $this->setWidgets(array(
        'testimonial_id' => new sfWidgetFormInputHidden(),
        'message'        => new sfWidgetFormTextarea(),
        'client_name'    => new sfWidgetFormInputText(),
        'is_active'         => new sfWidgetFormChoice(array(
            'choices' => array(0 => 'No', 1 => 'Yes'),
        )),
    ));

    $this->setValidators(array(
      'testimonial_id' => new sfValidatorChoice(array('choices' => array($this->getObject()->getTestimonialId()), 'empty_value' => $this->getObject()->getTestimonialId(), 'required' => false)),
      'message'        => new sfValidatorString(array('required' => false)),
      'client_name'    => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'is_active'      => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647)),    ));

    $this->widgetSchema->setNameFormat('testimonial[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    $this->widgetSchema->setLabels(array(
        'message'           => 'Testimonial',
        'client_name'       => 'Client Name',
        'is_active'         => 'Active',
    ));
  }
}
