<?php

/**
 * ArticleCategory form base class.
 *
 * @method ArticleCategory getObject() Returns the current form's model object
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseArticleCategoryForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'article_category_id'        => new sfWidgetFormInputHidden(),
      'display_name'               => new sfWidgetFormInputText(),
      'created_at'                 => new sfWidgetFormDateTime(),
      'created_by'                 => new sfWidgetFormInputText(),
      'updated_at'                 => new sfWidgetFormDateTime(),
      'updated_by'                 => new sfWidgetFormInputText(),
      'parent_article_category_id' => new sfWidgetFormInputText(),
      'display_order'              => new sfWidgetFormInputText(),
      'is_active'                  => new sfWidgetFormInputCheckbox(),
      'article_category_code'      => new sfWidgetFormInputText(),
      'content'                    => new sfWidgetFormTextarea(),
    ));

    $this->setValidators(array(
      'article_category_id'        => new sfValidatorChoice(array('choices' => array($this->getObject()->getArticleCategoryId()), 'empty_value' => $this->getObject()->getArticleCategoryId(), 'required' => false)),
      'display_name'               => new sfValidatorString(array('max_length' => 255)),
      'created_at'                 => new sfValidatorDateTime(),
      'created_by'                 => new sfValidatorString(array('max_length' => 45)),
      'updated_at'                 => new sfValidatorDateTime(),
      'updated_by'                 => new sfValidatorString(array('max_length' => 45)),
      'parent_article_category_id' => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647, 'required' => false)),
      'display_order'              => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647)),
      'is_active'                  => new sfValidatorBoolean(),
      'article_category_code'      => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'content'                    => new sfValidatorString(array('required' => false)),
    ));

    $this->widgetSchema->setNameFormat('article_category[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'ArticleCategory';
  }


}
