<?php

/**
 * Article form base class.
 *
 * @method Article getObject() Returns the current form's model object
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseArticleForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'article_id'          => new sfWidgetFormInputHidden(),
      'article_category_id' => new sfWidgetFormInputText(),
      'title'               => new sfWidgetFormInputText(),
      'keywords'            => new sfWidgetFormInputText(),
      'script_source'       => new sfWidgetFormInputText(),
      'display_order'       => new sfWidgetFormInputText(),
      'is_active'           => new sfWidgetFormInputCheckbox(),
      'created_at'          => new sfWidgetFormDateTime(),
      'created_by'          => new sfWidgetFormInputText(),
      'updated_at'          => new sfWidgetFormDateTime(),
      'updated_by'          => new sfWidgetFormInputText(),
      'article_code'        => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'article_id'          => new sfValidatorChoice(array('choices' => array($this->getObject()->getArticleId()), 'empty_value' => $this->getObject()->getArticleId(), 'required' => false)),
      'article_category_id' => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647, 'required' => false)),
      'title'               => new sfValidatorString(array('max_length' => 500)),
      'keywords'            => new sfValidatorString(array('max_length' => 500)),
      'script_source'       => new sfValidatorString(array('max_length' => 500)),
      'display_order'       => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647)),
      'is_active'           => new sfValidatorBoolean(),
      'created_at'          => new sfValidatorDateTime(),
      'created_by'          => new sfValidatorString(array('max_length' => 45)),
      'updated_at'          => new sfValidatorDateTime(),
      'updated_by'          => new sfValidatorString(array('max_length' => 45)),
      'article_code'        => new sfValidatorString(array('max_length' => 255, 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('article[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Article';
  }


}
