<?php

/**
 * ContentBlock form base class.
 *
 * @method ContentBlock getObject() Returns the current form's model object
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseContentBlockForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'code'       => new sfWidgetFormInputHidden(),
      'content'    => new sfWidgetFormTextarea(),
      'created_at' => new sfWidgetFormDateTime(),
      'created_by' => new sfWidgetFormInputText(),
      'updated_at' => new sfWidgetFormDateTime(),
      'updated_by' => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'code'       => new sfValidatorChoice(array('choices' => array($this->getObject()->getCode()), 'empty_value' => $this->getObject()->getCode(), 'required' => false)),
      'content'    => new sfValidatorString(),
      'created_at' => new sfValidatorDateTime(),
      'created_by' => new sfValidatorString(array('max_length' => 45)),
      'updated_at' => new sfValidatorDateTime(),
      'updated_by' => new sfValidatorString(array('max_length' => 45)),
    ));

    $this->widgetSchema->setNameFormat('content_block[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'ContentBlock';
  }


}
