<?php

/**
 * Message form base class.
 *
 * @method Message getObject() Returns the current form's model object
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseMessageForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'message_id'         => new sfWidgetFormInputHidden(),
      'first_name'         => new sfWidgetFormInputText(),
      'last_name'          => new sfWidgetFormInputText(),
      'interested_in'      => new sfWidgetFormInputText(),
      'preferred_response' => new sfWidgetFormInputText(),
      'email'              => new sfWidgetFormInputText(),
      'phone'              => new sfWidgetFormInputText(),
      'zip'                => new sfWidgetFormInputText(),
      'message'            => new sfWidgetFormTextarea(),
      'created_at'         => new sfWidgetFormDateTime(),
      'is_read'            => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'message_id'         => new sfValidatorChoice(array('choices' => array($this->getObject()->getMessageId()), 'empty_value' => $this->getObject()->getMessageId(), 'required' => false)),
      'first_name'         => new sfValidatorString(array('max_length' => 45, 'required' => false)),
      'last_name'          => new sfValidatorString(array('max_length' => 45, 'required' => false)),
      'interested_in'      => new sfValidatorString(array('max_length' => 45, 'required' => false)),
      'preferred_response' => new sfValidatorString(array('max_length' => 45, 'required' => false)),
      'email'              => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'phone'              => new sfValidatorString(array('max_length' => 11, 'required' => false)),
      'zip'                => new sfValidatorString(array('max_length' => 5, 'required' => false)),
      'message'            => new sfValidatorString(array('required' => false)),
      'created_at'         => new sfValidatorDateTime(array('required' => false)),
      'is_read'            => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647)),
    ));

    $this->widgetSchema->setNameFormat('message[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Message';
  }


}
