<?php

/**
 * NewsItem form base class.
 *
 * @method NewsItem getObject() Returns the current form's model object
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseNewsItemForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'news_item_id'   => new sfWidgetFormInputHidden(),
      'title'          => new sfWidgetFormInputText(),
      'external_url'   => new sfWidgetFormInputText(),
      'content'        => new sfWidgetFormTextarea(),
      'display_order'  => new sfWidgetFormInputText(),
      'is_active'      => new sfWidgetFormInputCheckbox(),
      'news_item_date' => new sfWidgetFormDateTime(),
      'created_at'     => new sfWidgetFormDateTime(),
      'created_by'     => new sfWidgetFormInputText(),
      'updated_at'     => new sfWidgetFormDateTime(),
      'updated_by'     => new sfWidgetFormInputText(),
      'news_item_type' => new sfWidgetFormInputText(),
      'event_end_date' => new sfWidgetFormDateTime(),
    ));

    $this->setValidators(array(
      'news_item_id'   => new sfValidatorChoice(array('choices' => array($this->getObject()->getNewsItemId()), 'empty_value' => $this->getObject()->getNewsItemId(), 'required' => false)),
      'title'          => new sfValidatorString(array('max_length' => 500)),
      'external_url'   => new sfValidatorString(array('max_length' => 500)),
      'content'        => new sfValidatorString(),
      'display_order'  => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647)),
      'is_active'      => new sfValidatorBoolean(),
      'news_item_date' => new sfValidatorDateTime(),
      'created_at'     => new sfValidatorDateTime(),
      'created_by'     => new sfValidatorString(array('max_length' => 45)),
      'updated_at'     => new sfValidatorDateTime(),
      'updated_by'     => new sfValidatorString(array('max_length' => 45)),
      'news_item_type' => new sfValidatorString(array('max_length' => 10, 'required' => false)),
      'event_end_date' => new sfValidatorDateTime(array('required' => false)),
    ));

    $this->widgetSchema->setNameFormat('news_item[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'NewsItem';
  }


}
