<?php

/**
 * Office form base class.
 *
 * @method Office getObject() Returns the current form's model object
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseOfficeForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'office_id'  => new sfWidgetFormInputHidden(),
      'address_1'  => new sfWidgetFormInputText(),
      'address_2'  => new sfWidgetFormInputText(),
      'address_3'  => new sfWidgetFormInputText(),
      'city'       => new sfWidgetFormInputText(),
      'state'      => new sfWidgetFormInputText(),
      'zip'        => new sfWidgetFormInputText(),
      'phone'      => new sfWidgetFormInputText(),
      'fax'        => new sfWidgetFormInputText(),
      'is_active'  => new sfWidgetFormInputCheckbox(),
      'created_at' => new sfWidgetFormDateTime(),
      'created_by' => new sfWidgetFormInputText(),
      'updated_at' => new sfWidgetFormDateTime(),
      'updated_by' => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'office_id'  => new sfValidatorChoice(array('choices' => array($this->getObject()->getOfficeId()), 'empty_value' => $this->getObject()->getOfficeId(), 'required' => false)),
      'address_1'  => new sfValidatorString(array('max_length' => 250)),
      'address_2'  => new sfValidatorString(array('max_length' => 250, 'required' => false)),
      'address_3'  => new sfValidatorString(array('max_length' => 250, 'required' => false)),
      'city'       => new sfValidatorString(array('max_length' => 250)),
      'state'      => new sfValidatorString(array('max_length' => 250)),
      'zip'        => new sfValidatorString(array('max_length' => 250)),
      'phone'      => new sfValidatorString(array('max_length' => 250, 'required' => false)),
      'fax'        => new sfValidatorString(array('max_length' => 250, 'required' => false)),
      'is_active'  => new sfValidatorBoolean(array('required' => false)),
      'created_at' => new sfValidatorDateTime(),
      'created_by' => new sfValidatorString(array('max_length' => 45)),
      'updated_at' => new sfValidatorDateTime(),
      'updated_by' => new sfValidatorString(array('max_length' => 45)),
    ));

    $this->widgetSchema->setNameFormat('office[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Office';
  }


}
