<?php

/**
 * Page form base class.
 *
 * @method Page getObject() Returns the current form's model object
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
abstract class BasePageForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'page_id'    => new sfWidgetFormInputHidden(),
      'module'     => new sfWidgetFormInputText(),
      'action'     => new sfWidgetFormInputText(),
      'title'      => new sfWidgetFormInputText(),
      'sub_title'  => new sfWidgetFormInputText(),
      'content'    => new sfWidgetFormTextarea(),
      'created_at' => new sfWidgetFormDateTime(),
      'created_by' => new sfWidgetFormInputText(),
      'updated_at' => new sfWidgetFormDateTime(),
      'updated_by' => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'page_id'    => new sfValidatorChoice(array('choices' => array($this->getObject()->getPageId()), 'empty_value' => $this->getObject()->getPageId(), 'required' => false)),
      'module'     => new sfValidatorString(array('max_length' => 45)),
      'action'     => new sfValidatorString(array('max_length' => 45)),
      'title'      => new sfValidatorString(array('max_length' => 45)),
      'sub_title'  => new sfValidatorString(array('max_length' => 45, 'required' => false)),
      'content'    => new sfValidatorString(array('required' => false)),
      'created_at' => new sfValidatorDateTime(),
      'created_by' => new sfValidatorString(array('max_length' => 45)),
      'updated_at' => new sfValidatorDateTime(),
      'updated_by' => new sfValidatorString(array('max_length' => 45)),
    ));

    $this->validatorSchema->setPostValidator(
      new sfValidatorPropelUnique(array('model' => 'Page', 'column' => array('module', 'action')))
    );

    $this->widgetSchema->setNameFormat('page[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Page';
  }


}
