<?php

/**
 * Testimonial form base class.
 *
 * @method Testimonial getObject() Returns the current form's model object
 *
 * @package    drspinks
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseTestimonialForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'testimonial_id' => new sfWidgetFormInputHidden(),
      'message'        => new sfWidgetFormTextarea(),
      'client_name'    => new sfWidgetFormInputText(),
      'is_active'      => new sfWidgetFormInputText(),
      'display_order'  => new sfWidgetFormInputText(),
      'created_at'     => new sfWidgetFormDateTime(),
      'created_by'     => new sfWidgetFormInputText(),
      'updated_at'     => new sfWidgetFormDateTime(),
      'updated_by'     => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'testimonial_id' => new sfValidatorChoice(array('choices' => array($this->getObject()->getTestimonialId()), 'empty_value' => $this->getObject()->getTestimonialId(), 'required' => false)),
      'message'        => new sfValidatorString(array('required' => false)),
      'client_name'    => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'is_active'      => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647)),
      'display_order'  => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647)),
      'created_at'     => new sfValidatorDateTime(),
      'created_by'     => new sfValidatorString(array('max_length' => 45)),
      'updated_at'     => new sfValidatorDateTime(),
      'updated_by'     => new sfValidatorString(array('max_length' => 45)),
    ));

    $this->widgetSchema->setNameFormat('testimonial[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Testimonial';
  }


}
