<?php

/**
 * returns a system formatted date
 * @param   string  $timestamp
 * @return  string
 */
function format_date($timestamp)
{
    $format = sfConfig::get('app_format_date');
    return (($timestamp != '') ? date($format, strtotime($timestamp)) : $timestamp);
}
/**
 * returns a system formatted date
 * @param   string  $time
 * @return  string
 */
function format_date_by_time($time)
{
    $format = sfConfig::get('app_format_date');
    return (($time != '') ? date($format, $time) : $time);
}

/**
 * returns a system formatted date
 * @param   string  $timestamp
 * @return  string
 */
function format_datetime($timestamp)
{
    $format = sfConfig::get('app_format_datetime');
    return (($timestamp != '') ? date($format, strtotime($timestamp)) : $timestamp);
}

/**
 * returns a system formatted time
 * @param   string  $timestamp
 * @return  string
 */
function format_time($timestamp)
{
    $format = sfConfig::get('app_format_time');
    return (($timestamp != '') ? date($format, strtotime($timestamp)) : $timestamp);
}

function format_combined_date($start, $end)
{
    $start_day  = date('d', strtotime($start));
    $start_month = date('m', strtotime($start));
    $start_year  = date('Y', strtotime($start));

    $end_day  = date('d', strtotime($end));
    $end_month = date('m', strtotime($end));
    $end_year  = date('Y', strtotime($end));

    if ($start_year != $end_year)
    {
        $date = format_date($start) . ' - ' . format_date($end);
    }
    else if ($start_month != $end_month)
    {
        $date = date('M', strtotime($start)) . ' ' . $start_day . ' - ' . date('M', strtotime($end)) . ' ' . $end_day . ', ' . date('Y', strtotime($start));
    }
    else
    {
        $date = date('M', strtotime($start)) . ' ' . $start_day . '-' . $end_day . ', ' . date('Y', strtotime($start));
    }

    return $date;
}

function highlight_keyword($string, $keyword)
{
    $string = str_replace(strtolower($keyword), '<strong>' . strtolower($keyword) . '</strong>',$string);
    $string = str_replace(ucwords(strtolower($keyword)), '<strong>' . ucwords(strtolower($keyword)) . '</strong>',$string);
    $string = str_replace(strtoupper($keyword), '<strong>' . strtoupper($keyword) . '</strong>',$string);

    return $string;
}
