<?php


/**
 * Base class that represents a query for the 'content_block' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.6.5-dev on:
 *
 * Sun Aug 19 17:09:03 2012
 *
 * @method     ContentBlockQuery orderByCode($order = Criteria::ASC) Order by the code column
 * @method     ContentBlockQuery orderByContent($order = Criteria::ASC) Order by the content column
 * @method     ContentBlockQuery orderByCreatedAt($order = Criteria::ASC) Order by the created_at column
 * @method     ContentBlockQuery orderByCreatedBy($order = Criteria::ASC) Order by the created_by column
 * @method     ContentBlockQuery orderByUpdatedAt($order = Criteria::ASC) Order by the updated_at column
 * @method     ContentBlockQuery orderByUpdatedBy($order = Criteria::ASC) Order by the updated_by column
 *
 * @method     ContentBlockQuery groupByCode() Group by the code column
 * @method     ContentBlockQuery groupByContent() Group by the content column
 * @method     ContentBlockQuery groupByCreatedAt() Group by the created_at column
 * @method     ContentBlockQuery groupByCreatedBy() Group by the created_by column
 * @method     ContentBlockQuery groupByUpdatedAt() Group by the updated_at column
 * @method     ContentBlockQuery groupByUpdatedBy() Group by the updated_by column
 *
 * @method     ContentBlockQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ContentBlockQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ContentBlockQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ContentBlock findOne(PropelPDO $con = null) Return the first ContentBlock matching the query
 * @method     ContentBlock findOneOrCreate(PropelPDO $con = null) Return the first ContentBlock matching the query, or a new ContentBlock object populated from the query conditions when no match is found
 *
 * @method     ContentBlock findOneByCode(string $code) Return the first ContentBlock filtered by the code column
 * @method     ContentBlock findOneByContent(string $content) Return the first ContentBlock filtered by the content column
 * @method     ContentBlock findOneByCreatedAt(string $created_at) Return the first ContentBlock filtered by the created_at column
 * @method     ContentBlock findOneByCreatedBy(string $created_by) Return the first ContentBlock filtered by the created_by column
 * @method     ContentBlock findOneByUpdatedAt(string $updated_at) Return the first ContentBlock filtered by the updated_at column
 * @method     ContentBlock findOneByUpdatedBy(string $updated_by) Return the first ContentBlock filtered by the updated_by column
 *
 * @method     array findByCode(string $code) Return ContentBlock objects filtered by the code column
 * @method     array findByContent(string $content) Return ContentBlock objects filtered by the content column
 * @method     array findByCreatedAt(string $created_at) Return ContentBlock objects filtered by the created_at column
 * @method     array findByCreatedBy(string $created_by) Return ContentBlock objects filtered by the created_by column
 * @method     array findByUpdatedAt(string $updated_at) Return ContentBlock objects filtered by the updated_at column
 * @method     array findByUpdatedBy(string $updated_by) Return ContentBlock objects filtered by the updated_by column
 *
 * @package    propel.generator.lib.model.om
 */
abstract class BaseContentBlockQuery extends ModelCriteria
{
	
	/**
	 * Initializes internal state of BaseContentBlockQuery object.
	 *
	 * @param     string $dbName The dabase name
	 * @param     string $modelName The phpName of a model, e.g. 'Book'
	 * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
	 */
	public function __construct($dbName = 'propel', $modelName = 'ContentBlock', $modelAlias = null)
	{
		parent::__construct($dbName, $modelName, $modelAlias);
	}

	/**
	 * Returns a new ContentBlockQuery object.
	 *
	 * @param     string $modelAlias The alias of a model in the query
	 * @param     Criteria $criteria Optional Criteria to build the query from
	 *
	 * @return    ContentBlockQuery
	 */
	public static function create($modelAlias = null, $criteria = null)
	{
		if ($criteria instanceof ContentBlockQuery) {
			return $criteria;
		}
		$query = new ContentBlockQuery();
		if (null !== $modelAlias) {
			$query->setModelAlias($modelAlias);
		}
		if ($criteria instanceof Criteria) {
			$query->mergeWith($criteria);
		}
		return $query;
	}

	/**
	 * Find object by primary key.
	 * Propel uses the instance pool to skip the database if the object exists.
	 * Go fast if the query is untouched.
	 *
	 * <code>
	 * $obj  = $c->findPk(12, $con);
	 * </code>
	 *
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    ContentBlock|array|mixed the result, formatted by the current formatter
	 */
	public function findPk($key, $con = null)
	{
		if ($key === null) {
			return null;
		}
		if ((null !== ($obj = ContentBlockPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
			// the object is alredy in the instance pool
			return $obj;
		}
		if ($con === null) {
			$con = Propel::getConnection(ContentBlockPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}
		$this->basePreSelect($con);
		if ($this->formatter || $this->modelAlias || $this->with || $this->select
		 || $this->selectColumns || $this->asColumns || $this->selectModifiers
		 || $this->map || $this->having || $this->joins) {
			return $this->findPkComplex($key, $con);
		} else {
			return $this->findPkSimple($key, $con);
		}
	}

	/**
	 * Find object by primary key using raw SQL to go fast.
	 * Bypass doSelect() and the object formatter by using generated code.
	 *
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con A connection object
	 *
	 * @return    ContentBlock A model object, or null if the key is not found
	 */
	protected function findPkSimple($key, $con)
	{
		$sql = 'SELECT CODE, CONTENT, CREATED_AT, CREATED_BY, UPDATED_AT, UPDATED_BY FROM content_block WHERE CODE = :p0';
		try {
			$stmt = $con->prepare($sql);
			$stmt->bindValue(':p0', $key, PDO::PARAM_STR);
			$stmt->execute();
		} catch (Exception $e) {
			Propel::log($e->getMessage(), Propel::LOG_ERR);
			throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
		}
		$obj = null;
		if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$obj = new ContentBlock();
			$obj->hydrate($row);
			ContentBlockPeer::addInstanceToPool($obj, (string) $key);
		}
		$stmt->closeCursor();

		return $obj;
	}

	/**
	 * Find object by primary key.
	 *
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con A connection object
	 *
	 * @return    ContentBlock|array|mixed the result, formatted by the current formatter
	 */
	protected function findPkComplex($key, $con)
	{
		// As the query uses a PK condition, no limit(1) is necessary.
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		$stmt = $criteria
			->filterByPrimaryKey($key)
			->doSelect($con);
		return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
	}

	/**
	 * Find objects by primary key
	 * <code>
	 * $objs = $c->findPks(array(12, 56, 832), $con);
	 * </code>
	 * @param     array $keys Primary keys to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    PropelObjectCollection|array|mixed the list of results, formatted by the current formatter
	 */
	public function findPks($keys, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
		}
		$this->basePreSelect($con);
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		$stmt = $criteria
			->filterByPrimaryKeys($keys)
			->doSelect($con);
		return $criteria->getFormatter()->init($criteria)->format($stmt);
	}

	/**
	 * Filter the query by primary key
	 *
	 * @param     mixed $key Primary key to use for the query
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKey($key)
	{
		return $this->addUsingAlias(ContentBlockPeer::CODE, $key, Criteria::EQUAL);
	}

	/**
	 * Filter the query by a list of primary keys
	 *
	 * @param     array $keys The list of primary key to use for the query
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKeys($keys)
	{
		return $this->addUsingAlias(ContentBlockPeer::CODE, $keys, Criteria::IN);
	}

	/**
	 * Filter the query on the code column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByCode('fooValue');   // WHERE code = 'fooValue'
	 * $query->filterByCode('%fooValue%'); // WHERE code LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $code The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function filterByCode($code = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($code)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $code)) {
				$code = str_replace('*', '%', $code);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(ContentBlockPeer::CODE, $code, $comparison);
	}

	/**
	 * Filter the query on the content column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByContent('fooValue');   // WHERE content = 'fooValue'
	 * $query->filterByContent('%fooValue%'); // WHERE content LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $content The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function filterByContent($content = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($content)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $content)) {
				$content = str_replace('*', '%', $content);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(ContentBlockPeer::CONTENT, $content, $comparison);
	}

	/**
	 * Filter the query on the created_at column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByCreatedAt('2011-03-14'); // WHERE created_at = '2011-03-14'
	 * $query->filterByCreatedAt('now'); // WHERE created_at = '2011-03-14'
	 * $query->filterByCreatedAt(array('max' => 'yesterday')); // WHERE created_at > '2011-03-13'
	 * </code>
	 *
	 * @param     mixed $createdAt The value to use as filter.
	 *              Values can be integers (unix timestamps), DateTime objects, or strings.
	 *              Empty strings are treated as NULL.
	 *              Use scalar values for equality.
	 *              Use array values for in_array() equivalent.
	 *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function filterByCreatedAt($createdAt = null, $comparison = null)
	{
		if (is_array($createdAt)) {
			$useMinMax = false;
			if (isset($createdAt['min'])) {
				$this->addUsingAlias(ContentBlockPeer::CREATED_AT, $createdAt['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($createdAt['max'])) {
				$this->addUsingAlias(ContentBlockPeer::CREATED_AT, $createdAt['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(ContentBlockPeer::CREATED_AT, $createdAt, $comparison);
	}

	/**
	 * Filter the query on the created_by column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByCreatedBy('fooValue');   // WHERE created_by = 'fooValue'
	 * $query->filterByCreatedBy('%fooValue%'); // WHERE created_by LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $createdBy The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function filterByCreatedBy($createdBy = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($createdBy)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $createdBy)) {
				$createdBy = str_replace('*', '%', $createdBy);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(ContentBlockPeer::CREATED_BY, $createdBy, $comparison);
	}

	/**
	 * Filter the query on the updated_at column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByUpdatedAt('2011-03-14'); // WHERE updated_at = '2011-03-14'
	 * $query->filterByUpdatedAt('now'); // WHERE updated_at = '2011-03-14'
	 * $query->filterByUpdatedAt(array('max' => 'yesterday')); // WHERE updated_at > '2011-03-13'
	 * </code>
	 *
	 * @param     mixed $updatedAt The value to use as filter.
	 *              Values can be integers (unix timestamps), DateTime objects, or strings.
	 *              Empty strings are treated as NULL.
	 *              Use scalar values for equality.
	 *              Use array values for in_array() equivalent.
	 *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function filterByUpdatedAt($updatedAt = null, $comparison = null)
	{
		if (is_array($updatedAt)) {
			$useMinMax = false;
			if (isset($updatedAt['min'])) {
				$this->addUsingAlias(ContentBlockPeer::UPDATED_AT, $updatedAt['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($updatedAt['max'])) {
				$this->addUsingAlias(ContentBlockPeer::UPDATED_AT, $updatedAt['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(ContentBlockPeer::UPDATED_AT, $updatedAt, $comparison);
	}

	/**
	 * Filter the query on the updated_by column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByUpdatedBy('fooValue');   // WHERE updated_by = 'fooValue'
	 * $query->filterByUpdatedBy('%fooValue%'); // WHERE updated_by LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $updatedBy The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function filterByUpdatedBy($updatedBy = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($updatedBy)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $updatedBy)) {
				$updatedBy = str_replace('*', '%', $updatedBy);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(ContentBlockPeer::UPDATED_BY, $updatedBy, $comparison);
	}

	/**
	 * Exclude object from result
	 *
	 * @param     ContentBlock $contentBlock Object to remove from the list of results
	 *
	 * @return    ContentBlockQuery The current query, for fluid interface
	 */
	public function prune($contentBlock = null)
	{
		if ($contentBlock) {
			$this->addUsingAlias(ContentBlockPeer::CODE, $contentBlock->getCode(), Criteria::NOT_EQUAL);
		}

		return $this;
	}

} // BaseContentBlockQuery