<?php


/**
 * Base class that represents a query for the 'users' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.6.5-dev on:
 *
 * Sun Aug 19 17:09:03 2012
 *
 * @method     UsersQuery orderByUserId($order = Criteria::ASC) Order by the user_id column
 * @method     UsersQuery orderByPassword($order = Criteria::ASC) Order by the password column
 * @method     UsersQuery orderByCreatedAt($order = Criteria::ASC) Order by the created_at column
 * @method     UsersQuery orderByUpdatedAt($order = Criteria::ASC) Order by the updated_at column
 * @method     UsersQuery orderByIsActive($order = Criteria::ASC) Order by the is_active column
 * @method     UsersQuery orderByCreatedBy($order = Criteria::ASC) Order by the created_by column
 * @method     UsersQuery orderByUpdatedBy($order = Criteria::ASC) Order by the updated_by column
 * @method     UsersQuery orderByEmail($order = Criteria::ASC) Order by the email column
 *
 * @method     UsersQuery groupByUserId() Group by the user_id column
 * @method     UsersQuery groupByPassword() Group by the password column
 * @method     UsersQuery groupByCreatedAt() Group by the created_at column
 * @method     UsersQuery groupByUpdatedAt() Group by the updated_at column
 * @method     UsersQuery groupByIsActive() Group by the is_active column
 * @method     UsersQuery groupByCreatedBy() Group by the created_by column
 * @method     UsersQuery groupByUpdatedBy() Group by the updated_by column
 * @method     UsersQuery groupByEmail() Group by the email column
 *
 * @method     UsersQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     UsersQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     UsersQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     Users findOne(PropelPDO $con = null) Return the first Users matching the query
 * @method     Users findOneOrCreate(PropelPDO $con = null) Return the first Users matching the query, or a new Users object populated from the query conditions when no match is found
 *
 * @method     Users findOneByUserId(string $user_id) Return the first Users filtered by the user_id column
 * @method     Users findOneByPassword(string $password) Return the first Users filtered by the password column
 * @method     Users findOneByCreatedAt(string $created_at) Return the first Users filtered by the created_at column
 * @method     Users findOneByUpdatedAt(string $updated_at) Return the first Users filtered by the updated_at column
 * @method     Users findOneByIsActive(int $is_active) Return the first Users filtered by the is_active column
 * @method     Users findOneByCreatedBy(string $created_by) Return the first Users filtered by the created_by column
 * @method     Users findOneByUpdatedBy(string $updated_by) Return the first Users filtered by the updated_by column
 * @method     Users findOneByEmail(string $email) Return the first Users filtered by the email column
 *
 * @method     array findByUserId(string $user_id) Return Users objects filtered by the user_id column
 * @method     array findByPassword(string $password) Return Users objects filtered by the password column
 * @method     array findByCreatedAt(string $created_at) Return Users objects filtered by the created_at column
 * @method     array findByUpdatedAt(string $updated_at) Return Users objects filtered by the updated_at column
 * @method     array findByIsActive(int $is_active) Return Users objects filtered by the is_active column
 * @method     array findByCreatedBy(string $created_by) Return Users objects filtered by the created_by column
 * @method     array findByUpdatedBy(string $updated_by) Return Users objects filtered by the updated_by column
 * @method     array findByEmail(string $email) Return Users objects filtered by the email column
 *
 * @package    propel.generator.lib.model.om
 */
abstract class BaseUsersQuery extends ModelCriteria
{
	
	/**
	 * Initializes internal state of BaseUsersQuery object.
	 *
	 * @param     string $dbName The dabase name
	 * @param     string $modelName The phpName of a model, e.g. 'Book'
	 * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
	 */
	public function __construct($dbName = 'propel', $modelName = 'Users', $modelAlias = null)
	{
		parent::__construct($dbName, $modelName, $modelAlias);
	}

	/**
	 * Returns a new UsersQuery object.
	 *
	 * @param     string $modelAlias The alias of a model in the query
	 * @param     Criteria $criteria Optional Criteria to build the query from
	 *
	 * @return    UsersQuery
	 */
	public static function create($modelAlias = null, $criteria = null)
	{
		if ($criteria instanceof UsersQuery) {
			return $criteria;
		}
		$query = new UsersQuery();
		if (null !== $modelAlias) {
			$query->setModelAlias($modelAlias);
		}
		if ($criteria instanceof Criteria) {
			$query->mergeWith($criteria);
		}
		return $query;
	}

	/**
	 * Find object by primary key.
	 * Propel uses the instance pool to skip the database if the object exists.
	 * Go fast if the query is untouched.
	 *
	 * <code>
	 * $obj  = $c->findPk(12, $con);
	 * </code>
	 *
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    Users|array|mixed the result, formatted by the current formatter
	 */
	public function findPk($key, $con = null)
	{
		if ($key === null) {
			return null;
		}
		if ((null !== ($obj = UsersPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
			// the object is alredy in the instance pool
			return $obj;
		}
		if ($con === null) {
			$con = Propel::getConnection(UsersPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}
		$this->basePreSelect($con);
		if ($this->formatter || $this->modelAlias || $this->with || $this->select
		 || $this->selectColumns || $this->asColumns || $this->selectModifiers
		 || $this->map || $this->having || $this->joins) {
			return $this->findPkComplex($key, $con);
		} else {
			return $this->findPkSimple($key, $con);
		}
	}

	/**
	 * Find object by primary key using raw SQL to go fast.
	 * Bypass doSelect() and the object formatter by using generated code.
	 *
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con A connection object
	 *
	 * @return    Users A model object, or null if the key is not found
	 */
	protected function findPkSimple($key, $con)
	{
		$sql = 'SELECT USER_ID, PASSWORD, CREATED_AT, UPDATED_AT, IS_ACTIVE, CREATED_BY, UPDATED_BY, EMAIL FROM users WHERE USER_ID = :p0';
		try {
			$stmt = $con->prepare($sql);
			$stmt->bindValue(':p0', $key, PDO::PARAM_STR);
			$stmt->execute();
		} catch (Exception $e) {
			Propel::log($e->getMessage(), Propel::LOG_ERR);
			throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
		}
		$obj = null;
		if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$obj = new Users();
			$obj->hydrate($row);
			UsersPeer::addInstanceToPool($obj, (string) $key);
		}
		$stmt->closeCursor();

		return $obj;
	}

	/**
	 * Find object by primary key.
	 *
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con A connection object
	 *
	 * @return    Users|array|mixed the result, formatted by the current formatter
	 */
	protected function findPkComplex($key, $con)
	{
		// As the query uses a PK condition, no limit(1) is necessary.
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		$stmt = $criteria
			->filterByPrimaryKey($key)
			->doSelect($con);
		return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
	}

	/**
	 * Find objects by primary key
	 * <code>
	 * $objs = $c->findPks(array(12, 56, 832), $con);
	 * </code>
	 * @param     array $keys Primary keys to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    PropelObjectCollection|array|mixed the list of results, formatted by the current formatter
	 */
	public function findPks($keys, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
		}
		$this->basePreSelect($con);
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		$stmt = $criteria
			->filterByPrimaryKeys($keys)
			->doSelect($con);
		return $criteria->getFormatter()->init($criteria)->format($stmt);
	}

	/**
	 * Filter the query by primary key
	 *
	 * @param     mixed $key Primary key to use for the query
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKey($key)
	{
		return $this->addUsingAlias(UsersPeer::USER_ID, $key, Criteria::EQUAL);
	}

	/**
	 * Filter the query by a list of primary keys
	 *
	 * @param     array $keys The list of primary key to use for the query
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKeys($keys)
	{
		return $this->addUsingAlias(UsersPeer::USER_ID, $keys, Criteria::IN);
	}

	/**
	 * Filter the query on the user_id column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByUserId('fooValue');   // WHERE user_id = 'fooValue'
	 * $query->filterByUserId('%fooValue%'); // WHERE user_id LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $userId The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByUserId($userId = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($userId)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $userId)) {
				$userId = str_replace('*', '%', $userId);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(UsersPeer::USER_ID, $userId, $comparison);
	}

	/**
	 * Filter the query on the password column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByPassword('fooValue');   // WHERE password = 'fooValue'
	 * $query->filterByPassword('%fooValue%'); // WHERE password LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $password The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByPassword($password = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($password)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $password)) {
				$password = str_replace('*', '%', $password);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(UsersPeer::PASSWORD, $password, $comparison);
	}

	/**
	 * Filter the query on the created_at column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByCreatedAt('2011-03-14'); // WHERE created_at = '2011-03-14'
	 * $query->filterByCreatedAt('now'); // WHERE created_at = '2011-03-14'
	 * $query->filterByCreatedAt(array('max' => 'yesterday')); // WHERE created_at > '2011-03-13'
	 * </code>
	 *
	 * @param     mixed $createdAt The value to use as filter.
	 *              Values can be integers (unix timestamps), DateTime objects, or strings.
	 *              Empty strings are treated as NULL.
	 *              Use scalar values for equality.
	 *              Use array values for in_array() equivalent.
	 *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByCreatedAt($createdAt = null, $comparison = null)
	{
		if (is_array($createdAt)) {
			$useMinMax = false;
			if (isset($createdAt['min'])) {
				$this->addUsingAlias(UsersPeer::CREATED_AT, $createdAt['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($createdAt['max'])) {
				$this->addUsingAlias(UsersPeer::CREATED_AT, $createdAt['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(UsersPeer::CREATED_AT, $createdAt, $comparison);
	}

	/**
	 * Filter the query on the updated_at column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByUpdatedAt('2011-03-14'); // WHERE updated_at = '2011-03-14'
	 * $query->filterByUpdatedAt('now'); // WHERE updated_at = '2011-03-14'
	 * $query->filterByUpdatedAt(array('max' => 'yesterday')); // WHERE updated_at > '2011-03-13'
	 * </code>
	 *
	 * @param     mixed $updatedAt The value to use as filter.
	 *              Values can be integers (unix timestamps), DateTime objects, or strings.
	 *              Empty strings are treated as NULL.
	 *              Use scalar values for equality.
	 *              Use array values for in_array() equivalent.
	 *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByUpdatedAt($updatedAt = null, $comparison = null)
	{
		if (is_array($updatedAt)) {
			$useMinMax = false;
			if (isset($updatedAt['min'])) {
				$this->addUsingAlias(UsersPeer::UPDATED_AT, $updatedAt['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($updatedAt['max'])) {
				$this->addUsingAlias(UsersPeer::UPDATED_AT, $updatedAt['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(UsersPeer::UPDATED_AT, $updatedAt, $comparison);
	}

	/**
	 * Filter the query on the is_active column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByIsActive(1234); // WHERE is_active = 1234
	 * $query->filterByIsActive(array(12, 34)); // WHERE is_active IN (12, 34)
	 * $query->filterByIsActive(array('min' => 12)); // WHERE is_active > 12
	 * </code>
	 *
	 * @param     mixed $isActive The value to use as filter.
	 *              Use scalar values for equality.
	 *              Use array values for in_array() equivalent.
	 *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByIsActive($isActive = null, $comparison = null)
	{
		if (is_array($isActive)) {
			$useMinMax = false;
			if (isset($isActive['min'])) {
				$this->addUsingAlias(UsersPeer::IS_ACTIVE, $isActive['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($isActive['max'])) {
				$this->addUsingAlias(UsersPeer::IS_ACTIVE, $isActive['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(UsersPeer::IS_ACTIVE, $isActive, $comparison);
	}

	/**
	 * Filter the query on the created_by column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByCreatedBy('fooValue');   // WHERE created_by = 'fooValue'
	 * $query->filterByCreatedBy('%fooValue%'); // WHERE created_by LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $createdBy The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByCreatedBy($createdBy = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($createdBy)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $createdBy)) {
				$createdBy = str_replace('*', '%', $createdBy);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(UsersPeer::CREATED_BY, $createdBy, $comparison);
	}

	/**
	 * Filter the query on the updated_by column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByUpdatedBy('fooValue');   // WHERE updated_by = 'fooValue'
	 * $query->filterByUpdatedBy('%fooValue%'); // WHERE updated_by LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $updatedBy The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByUpdatedBy($updatedBy = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($updatedBy)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $updatedBy)) {
				$updatedBy = str_replace('*', '%', $updatedBy);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(UsersPeer::UPDATED_BY, $updatedBy, $comparison);
	}

	/**
	 * Filter the query on the email column
	 *
	 * Example usage:
	 * <code>
	 * $query->filterByEmail('fooValue');   // WHERE email = 'fooValue'
	 * $query->filterByEmail('%fooValue%'); // WHERE email LIKE '%fooValue%'
	 * </code>
	 *
	 * @param     string $email The value to use as filter.
	 *              Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function filterByEmail($email = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($email)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $email)) {
				$email = str_replace('*', '%', $email);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(UsersPeer::EMAIL, $email, $comparison);
	}

	/**
	 * Exclude object from result
	 *
	 * @param     Users $users Object to remove from the list of results
	 *
	 * @return    UsersQuery The current query, for fluid interface
	 */
	public function prune($users = null)
	{
		if ($users) {
			$this->addUsingAlias(UsersPeer::USER_ID, $users->getUserId(), Criteria::NOT_EQUAL);
		}

		return $this;
	}

} // BaseUsersQuery